# lib/poptI.c File Reference

Popt tables for install modes. More...

`#include "system.h"`
`#include <rpmio.h>`
`#include <rpmcli.h>`
`#include "debug.h"`
Include dependency graph for poptI.c:

Go to the source code of this file.

## Defines

#define | POPT_RELOCATE -1021
#define | POPT_EXCLUDEPATH -1022
#define | POPT_ROLLBACK -1023
#define | POPT_ROLLBACK_EXCLUDE -1024
#define | POPT_AUTOROLLBACK_GOAL -1036
#define | alloca_strdup(_s) strcpy(alloca(strlen(_s)+1), (_s))

## Functions

time_t | get_date (const char *p, void *now)
static void | argerror (const char *desc)
| Print a message and exit.
static void | installArgCallback (poptContext con, enum poptCallbackReason reason, const struct poptOption *opt, const char *arg, const void *data)

## Variables

struct rpmQVKArguments_s | rpmIArgs
struct poptOption | rpmInstallPoptTable []

## Detailed Description

Popt tables for install modes.

Definition in file poptI.c.

## Define Documentation

#define alloca_strdup | ( | _s |  | ) | strcpy(alloca(strlen(_s)+1), (_s))

Definition at line 31 of file poptI.c.

#define POPT_AUTOROLLBACK_GOAL -1036

Definition at line 29 of file poptI.c.

Referenced by installArgCallback().

#define POPT_EXCLUDEPATH -1022

Definition at line 25 of file poptI.c.

Referenced by installArgCallback().

#define POPT_RELOCATE -1021

Definition at line 24 of file poptI.c.

Referenced by installArgCallback().

#define POPT_ROLLBACK -1023

Definition at line 26 of file poptI.c.

Referenced by installArgCallback().

#define POPT_ROLLBACK_EXCLUDE -1024

Definition at line 27 of file poptI.c.

Referenced by installArgCallback().

## Function Documentation

static void argerror | ( | const char * | desc | ) | `[static]`

Print a message and exit.

Todo:
  (CLI embedding) Use rpmlog/rpmlog instead of fprintf, remove exit.

Parameters:

  | desc | message

Definition at line 39 of file poptI.c.

References _, __progname, and EXIT_FAILURE.

Referenced by installArgCallback().

time_t get_date | ( | const char * | p,
|  | void * | now |
| ) |  |  |

static void installArgCallback | ( | poptContext | con,
|  | enum poptCallbackReason | reason,
|  | const struct poptOption * | opt,
|  | const char * | arg,
|  | const void * | data |
| ) |  |  | `[static]`

Definition at line 51 of file poptI.c.

References _, _noTransScripts, _noTransTriggers, alloca_strdup, rpmQVKArguments_s::arbtid, argerror(), get_date(), INSTALL_INSTALL, rpmQVKArguments_s::installInterfaceFlags, rpmRelocation_s::newPath, rpmQVKArguments_s::noDeps, rpmQVKArguments_s::numrbtidExcludes, rpmQVKArguments_s::numRelocations, rpmRelocation_s::oldPath, POPT_AUTOROLLBACK_GOAL, POPT_EXCLUDEPATH, POPT_RELOCATE, POPT_ROLLBACK, POPT_ROLLBACK_EXCLUDE, rpmQVKArguments_s::qva_flags, rpmQVKArguments_s::rbtid, rpmQVKArguments_s::rbtidExcludes, rpmQVKArguments_s::relocations, RPMCLI_POPT_NOCONTEXTS, RPMCLI_POPT_NODEPS, RPMCLI_POPT_NODIGEST, RPMCLI_POPT_NOFDIGESTS, RPMCLI_POPT_NOHDRCHK, RPMCLI_POPT_NOSCRIPTS, RPMCLI_POPT_NOSIGNATURE, rpmlog(), RPMLOG_INFO, RPMTRANS_FLAG_NOCONTEXTS, RPMTRANS_FLAG_NOFDIGESTS, rpmQVKArguments_s::transFlags, VERIFY_DIGEST, VERIFY_HDRCHK, VERIFY_SIGNATURE, xrealloc(), and xstrdup().